/* graph.c
   E.V. may 99
   legge un grafo da file, lo carica in memoria e lo stampa a video
   Il formato del file e':
   <numero nodi>
   {<indice nodo>}
   <numero archi>
   {<indice nodo> <indice nodo>}

*/

#include<stdlib.h>
#include<stdio.h>

typedef int boolean;
#define true 1
#define false 0


struct node_list{
   struct node_list * next_node_ptr;
   struct arc_list * next_arc_ptr;
   int value;
};

struct arc_list{
   struct node_list * connected_node_ptr;
   struct arc_list * next_arc_ptr;
};

void main(void);

void main(void)
{
   FILE * handle;
   int count;
   int n_nodes;
   int n_arcs;
   struct node_list * root_ptr;
   struct node_list ** node_to_insert_ptr_ptr;
   struct node_list * node_to_print_ptr;

   struct node_list * node_to_scan_ptr;
   struct node_list * source_node_ptr;
   struct node_list * dest_node_ptr;
   struct arc_list ** arc_to_scan_ptr_ptr;
   struct arc_list * arc_to_print_ptr;
   int source;
   int dest;
   boolean node_found;

   handle=fopen("graph.txt","r");

   /* lettura dei nodi */
   fscanf(handle,"%d",&n_nodes);
   node_to_insert_ptr_ptr=&root_ptr;
   for(count=0;count<n_nodes;count++)
   {
       (*node_to_insert_ptr_ptr)=(struct node_list *)malloc(sizeof(struct node_list));
       fscanf(handle,"%d",&((*node_to_insert_ptr_ptr)->value));
       (*node_to_insert_ptr_ptr)->next_arc_ptr=NULL;
       (*node_to_insert_ptr_ptr)->next_node_ptr=NULL;
       node_to_insert_ptr_ptr=&((*node_to_insert_ptr_ptr)->next_node_ptr);
   }

   /* lettura degli archi */
   fscanf(handle,"%d",&n_arcs);
   for(count=0;count<n_arcs;count++)
   {
       fscanf(handle,"%d %d",&source, &dest);

       /*ricerca il puntatore al nodo destinazione*/
       node_to_scan_ptr=root_ptr;
       node_found=false;
       while(node_to_scan_ptr!=NULL && node_found==false)
       { if(node_to_scan_ptr->value==dest)
         {
            node_found=true;
            dest_node_ptr=node_to_scan_ptr;
         }else
            node_to_scan_ptr=node_to_scan_ptr->next_node_ptr;
       }
       if(node_found==false)
          printf("\n source node not found for arc <%d,%d> !",source,dest);


       /*ricerca il puntatore al nodo sorgente*/
       node_to_scan_ptr=root_ptr;
       node_found=false;
       while(node_to_scan_ptr!=NULL && node_found==false)
       { if(node_to_scan_ptr->value==source)
         {  node_found=true;
            source_node_ptr=node_to_scan_ptr;
         }else
            node_to_scan_ptr=node_to_scan_ptr->next_node_ptr;
       }
       if(node_found==false)
          printf("\n source node not found for arc <%d,%d> !",source,dest);


       /*inserzione dell'arco sulla lista del nodo source*/
       arc_to_scan_ptr_ptr=&source_node_ptr->next_arc_ptr;
       while(*arc_to_scan_ptr_ptr!=NULL)
       {   arc_to_scan_ptr_ptr=&(*arc_to_scan_ptr_ptr)->next_arc_ptr;
       }
       (*arc_to_scan_ptr_ptr) =
                          (struct arc_list *)malloc(sizeof(struct arc_list));
       (*arc_to_scan_ptr_ptr)->connected_node_ptr = dest_node_ptr;
       (*arc_to_scan_ptr_ptr)->next_arc_ptr=NULL;
   }

   /* visita del grafo */
   node_to_print_ptr=root_ptr;
   while(node_to_print_ptr!=NULL)
   {
       printf("\n %d is connected to ",node_to_print_ptr->value);
       arc_to_print_ptr=node_to_print_ptr->next_arc_ptr;
       while(arc_to_print_ptr!=NULL)
       {  printf("%d ",arc_to_print_ptr->connected_node_ptr->value);
          arc_to_print_ptr=arc_to_print_ptr->next_arc_ptr;
       }
       node_to_print_ptr=node_to_print_ptr->next_node_ptr;
   }
}

